package ms;

/*
 * This program is Java Object for synonym term|cat.
 * It includes two fields term|category.
 */

import java.io.*;

public class TermCat
{
	// public constructor
	public TermCat()
	{
		Init();
	}

	public TermCat(String term, String cat)
	{
		term_ = term;
		cat_ = cat;
	}

    // public methods
	public void SetTerm(String term)
	{
		term_ = term;
	}

	public void SetCat(String cat)
	{
		cat_ = cat;
	}

	public String GetTerm()
	{
		return term_;
	}

	public String GetCat()
	{
		return cat_;
	}

	// must override: for comparing TermCat objects with same hashTable key
	public boolean equals(Object anObject)
    {
		boolean flag = false;
        if((anObject != null) && (anObject instanceof TermCat))
        {
            if((term_.equals(((TermCat) anObject).GetTerm()))
            && (cat_.equals(((TermCat) anObject).GetCat())))
            {
                flag = true;
            }
        }

        return flag;
    }

	// must override: for hashTable key
	public int hashCode()
	{
		int hashCode = ToString().hashCode();
		return hashCode;
	}

	public String ToString()
	{
		String outStr = term_ + SP + cat_;
		return outStr;
	}

	public String ToDbString()
	{
		String outStr = ToDbFormat(term_) + SP + term_ + SP + cat_;
		return outStr;
	}

	// private methods
	private void Init()
	{
		term_ = new String();
		cat_ = new String();
	}

	// Strip Punctuations & Lower case
	private static String ToDbFormat(String inStr)
    {
        // Strip Punctuations
        int length = inStr.length();
        char[] temp = new char[length];
        int index = 0;
        for(int i = 0; i < length; i++)
        {
            char tempChar = inStr.charAt(i);
            if(IsPunctuation(tempChar) == false)
            {
                temp[index] = tempChar;
                index++;
            }
        }

        String outStr = new String(temp);
        return outStr.trim().toLowerCase();
    }

    private static boolean IsPunctuation(char inChar)
    {
        boolean isPunctuation = false;
        int type = Character.getType(inChar);

        // check if the input is a punctuation
        if((type == Character.DASH_PUNCTUATION)         // -
        || (type == Character.START_PUNCTUATION)        // ( { [
        || (type == Character.END_PUNCTUATION)          // ) } ]
        || (type == Character.CONNECTOR_PUNCTUATION)    // _
        || (type == Character.OTHER_PUNCTUATION)        // !@#%&*\:;"',.?/
        || (type == Character.MATH_SYMBOL)              // ~ + = | < >
        || (type == Character.CURRENCY_SYMBOL)          // $
        || (type == Character.MODIFIER_SYMBOL))         // ` ^
        {
            isPunctuation = true;
        }

        return isPunctuation;
    }

    // data member
	final private static String SP = "|";
	private String term_;	// term 
	private String cat_;	// category
}
